var mongoose = require('mongoose')
var fs = require('fs')

let apiobject = function() {
  this.mongodb = null
  this.mlabCredentials = null
}

apiobject.prototype.mongoConnect = function() {
  if(this.mlabCredentials == null) throw 'pls set mongodb connections with setMlabCredentials(object) function ...'
  else this.mongodb = mongoose.createConnection('mongodb://' + this.mlabCredentials.user + ':' + this.mlabCredentials.passwd + this.mlabCredentials.url, {useMongoClient: true})
}

apiobject.prototype.mongoClose = function() {
  this.mongodb = mongoose.disconnect()
  this.mongodb = null
}

apiobject.prototype.setMlabCredentials = function(object) {
  this.mlabCredentials = object
}

apiobject.prototype.closeMlabCredentials = function(object) {
  this.mlabCredentials = null
}

apiobject.prototype.addFunction = function(defs, rFunction) {
  model[defs.name] = function (defaults, callback) {
    rFunction(defaults)
    .then(function (fResponse) {
        callback(false, null, {data: fResponse.document})
    })
    .catch((access) => {
        callback(true, {success: false, error: true, lCode: '.API-OBJECT-E1', func: '@rFunction', msg: 'Valami hiba a funkcióban!', type: 'error', data: null}, null)
    })
  }
}

module.exports = apiobject
